import html2canvas from 'html2canvas'

const userInfoModule = {
  namespaced: true,
  state: () => ({
    active: null,
    img: null,
    token: localStorage.getItem('token') || null,
  }),
  mutations: {
    changeActive(state, payload) {
      state.active = payload
    },
    setToken(state, token){
      state.token = token
      localStorage.setItem('token', token)
      console.log('route', token)

    },
    sendMessage (state, payload) {
      uniWebview.postMessage({
          data: payload
      });
    },
    setImg (state, payload) {
      state.img = payload
    }
  },
  actions: {
    //保存图片
    saveImage(context, refs) {
      console.log('saveImage', refs);
      // const scaleBy = window && window.devicePixelRatio>1?window.devicePixelRatio:1;
      // if(!refs) return
      // 第一个参数是需要生成截图的元素,第二个是自己需要配置的参数,宽高等
      html2canvas(refs, {
        backgroundColor: null, //画出来的图片有白色的边框,不要可设置背景为透明色（null）
        useCORS: true, //支持图片跨域
        scale: window.devicePixelRatio, //设置放大的倍数
      }).then((canvas) => {
        // 把生成的base64位图片上传到服务器,生成在线图片地址
        let url = canvas.toDataURL("image/png"); // toDataURL: 图片格式转成 base64
        context.commit('setImg', url)
        // this.img = url;
        // //将图片下载到本地
        // let a = document.createElement("a"); // 生成一个a元素
        // let event = new MouseEvent("click"); // 创建一个单击事件
        // a.download = name || "截图名称"; // 设置图片名称没有设置则为默认
        // a.href = this.imgUrl; // 将生成的URL设置为a.href属性
        // a.dispatchEvent(event); // 触发a的单击事件
      });
    },
  },
  getters: {
    getActive(state) {
      return state.active
    }
  }
}

export default userInfoModule
